orig = 0x7c00
magic:
	jmps begin
	nop
//.space 0x3b total (30 two to the left)
version:
.space 8
sectsize:
.space 2
clustsize:
.space 1
nresrv:
.space 2
nfats:
.space 1
rootsize:
.space 2
volsize:
.space 2
mediadesc:
.space 1
fatsize:
.space 2
trksize:
.space 2
nheads:
.space 2
nhiddenlo:
.space 2
nhiddenhi:
.space 2
bigvolsize:
.space 4
driveno:
.space 1
reserved:
.space 1
bootsig:
.space 1
volid:
.space 4
label:
.space 11
type:
.space 8

//FAT directory entry.
//mov is botched.
 
Dname = 0x00
Dnamesz	= 0x0B
Dext = 0x08
Dattr = 0x0B
Dtime = 0x16
Ddate = 0x18
Dstart = 0x1A
Dlengthlo = 0x1C
Dlengthhi = 0x1E

Dirsz=0x20
Diradjsz = 0x10 // 512/Dirsz

//Data is kept on the stack, indexed by bp.

Xdap = 0x00		// disc address packet 
Xrootsz = 0x10		// file data area 
Xdrive = 0x12		// boot drive, passed by BIOS or MBR
Xtotal = 0x14		// sum of allocated data above

LOADOFF = 0
LOADSEG = 0x1000	//where you used to load the code (64KB)
DIROFF = 0x0200

away = 0x0000


begin:
	cli
	sub ax, ax
	mov ax, ss
	mov ax, ds
	mov ax, es
	mov ax, gs
	mov $orig-Xtotal, sp	//jump over the bios/mbr data
	mov sp, bp
	mov dl, Xdrive(bp)	//save the drive

	//cd starts at 7C0, go to 0:7C00
	push ax
	mov $nxt+orig, ax
	push ax
	lret
nxt:
	sti

	mov	$orig + hi, si	//say hello
	call	puts
	//--S call bigreal	//change to bigreal mode...

	movb $0x41, ah	//check extensions present
	mov $0x55aa, bx
	mov Xdrive(bp), dl
	int $0x13		//CF set on failure
	jcs jmp01

	cmp $0xaa55, bx	//check for buggy bios
	jne jmp01

	and 0x0001, cx
	je ioerror

		/* rCX contains 0x0001 */
	mov $0x0010, Xdap(bp)	//reserved + packet size
	mov cx, Xdap+2(bp)		//reserved + #blocks to transfer (1)
	dec cx
	mov cx, Xdap+12(bp)
	mov cx, Xdap+14(bp)
	call dreset
jmp00:
	mov orig+volid, ax		//Xrootlo
	mov orig+volid+2, dx	//Xroothi

	mov $orig+DIROFF, bx
	call sectread		// read the root directory 
	mov $Diradjsz, bx	//nentries
	mov $orig+DIROFF, di	//name of the file
cmp00:
	push di		//save directory for later if it matches
	//pusha		
	//mov di, si	//print dirname (next is a pointer will start with zero :-))
	//call puts
	//mov $'c', al	
	//call putc
	//popa
	mov $orig+bootfile, si	//'9load '
	mov $Dnamesz, cx
	rep
	cmpsb
	pop di
	je jmp02
	dec bx		//nentries--
	je jmp01
	add $Dirsz, di
	jmp cmp00
jmp01:
	call ioerror
jmp02:
	sub bx, bx		// a handy value 
	mov orig+rootsize, ax	// calculate and save Xrootsz 
	mov $Dirsz, cx
	mul cx
	
	mov orig+sectsize, cx
	push cx
	dec cx
	add cx, ax
	adc bx, dx
	pop cx	// sectsize
	div cx
	push ax	//Xrootsz


	//di points to the entry...
	mov Dstart(di), ax
	dec ax
	dec ax
	movb orig+clustsize, cl
	subb ch, ch
	mul cx
	mov orig+volid, cx
	add cx, ax
	mov orig+volid+2, cx
	adc cx, dx
	pop cx
	add cx, ax
	adc bx, dx
	push ax	//calculate the number of sectors to read
	push dx
	mov Dlengthlo(di), ax
	mov Dlengthhi(di), dx
	mov orig+sectsize, cx
	push cx
	dec cx
	add cx, ax
	adc bx, dx
	pop cx
	div cx
	mov ax, cx
	pop dx
	pop ax

	pusha
	jmp bigreal
	popa

	mov $LOADSEG, bx
	mov bx, gs
	mov $LOADOFF, bx
readboot:
	call sectread
	mov orig+sectsize, di		//bump addresses/counts 
	add di, bx
	jncs incsecno
	mov gs, di			//inc sec count
	add $0x1000, di
	mov di, gs
incsecno:
	sub di, di
	inc ax
	adc di, dx
	loop readboot
	mov $LOADSEG, di
	mov di, ds
	ljmp 0x1000:LOADOFF	//LOADSEG:LOADOFF ass!embler

//----functions...


bigreal:
	//call dumpsegs
	cli
	lgdt gdtaddr+orig

				//switch to protected
	.byte 0x0f, 0x20, 0xc0	//mov cr0, eax
	orb $1, al
	.byte 0x0f, 0x22, 0xc0	//mov eax, cr0
	
	mov $next+orig, ax
	jmp ax
next:
	movb $0x08, bl
	movb $0x00, bh
	mov bx, es

	andb $0xfe, al			//back to real mode
	.byte 0x0f, 0x22, 0xc0	//mov eax, cr0
	sti

	inb $0x92			//turn on A20 line, may not work on old
	orb $2, al
	outb $0x92

	//call dumpsegs
ret


dreset:
	pusha
	sub ax, ax	//ah = 0, reset
	movb Xdrive(bp), dl
	int $0x13
	orb ah, ah
	popa
	jne ioerror
ret

moveblk:
	cld
	mov sp, bp
	sub ax, ax
	mov ax, ds
	opsz	
	mov Xdap+4(bp), si	//buffer offset taken from sectread
	opsz	//mov [bp+06], edi
	mov 0x6(bp), di
	opsz	//mov [bp+0a], ecx
	mov $0x1, cx
	rep
	.byte 0x67, 0x66, 0x26, 0xa5	//movsd ds:esi to es:edi
ret

//
// Read a sector from a disc. On entry:
//   rDX:rAX	sector number
//   rES:rBX	buffer address
//
sectread:
	mov 5, di	//retry count	
retry:
	pusha	//may be trashed by bios... uff

	mov bx, Xdap+4(bp)	//buffer : offset
	mov gs, di			// buffer seg:
	mov di, Xdap+6(bp)	
	mov ax, Xdap+8(bp)	//LBA 64 bits
	mov dx, Xdap+10(bp)

	mov bp, si
	movb $0x42, ah
	movb Xdrive(bp), dl
	int $0x13
	jncs biosrdret	//CF set on failure

	popa
	dec di
	jes ioerror

	call dreset
	//pusha	may be trashed by bios...

	//movb $'r', al	
	//call	putc
	//popa
	jmp retry
ioerror:
	mov $orig+ioerr, si
	call puts
wait:
	sub ax, ax
	int $0x16
reset:
	sub bx, bx
	mov bx, es
	mov 0x0472, bx		//warm start code address
	mov 0x1234, ax		//warm start code
	.byte 0x26, 0x89, 0x07	//mov ax, es:(bx)
	ljmp 0xffff:away		//jump to reset

biosrdret:
	//movb $'*', al
	//call	putc
	//popa
ret

//--end debug

puts:	
	push cx	//S
	mov $10, cx
putsag:
	cld
	lodsb
	cmpb	$0, al
	jes	end
	dec cx
	jes	end
	call	putc
	jmp	putsag
end:
	pop cx	//S
	ret

putc:	// write the char in al to video

// write to video
	pusha
	movb	$0xe, ah
	int	$0x10
	popa
	ret


gdt_limit = gdt_end - gdt - 1
gdtentrysz = gdt_end - gdt

gdtaddr:
	.word	gdt_limit
	.word	orig+gdt-gdt_entrysz, 0x0000	                /* we know the offset */


gdt:
//selgdt 0x8
/* unreal data segment at 000*/
	.word	0xffff, 0x0000
	.byte	0x00, 0x93, 0xcf, 0x00	
gdt_end:

bootfile:
	<9LOAD      \0>
hi:
	<Pbs3\r\n\0>
ioerr:
	<IOer>
bye:
	<key\0>

finish:
	<ffffffffffffffffffffffff\0> //to tell me if it ended...