orig = 0x7c00

//FAT directory entry.
//mov is botched.
 
Dname = 0x00
Dext = 0x08
Dattr = 0x0B
Dtime = 0x16
Ddate = 0x18
Dstart = 0x1A
Dlengthlo = 0x1C
Dlengthhi = 0x1E

Dirsz=0x20

//Data is kept on the stack, indexed by rBP.

Xdap=0x00		// disc address packet 
Xrootsz=0x10		// file data area 
Xdrive=0x12		// boot drive, passed by BIOS or MBR
Xtotal=0x14		// sum of allocated data above 


start:
	jmps begin
	nop
//.space 0x3b total (30 two to the left)
version:
.space 8
sectsize:
.space 2
clustsize:
.space 1
nresrv:
.space 2
nfats:
.space 1
rootsize:
.space 2
volsize:
.space 2
mediadesc:
.space 1
fatsize:
.space 2
trksize:
.space 2
nheads:
.space 2
nhiddenlo:
.space 2
nhiddenhi:
.space 2
bigvolsize:
.space 4
driveno:
.space 1
reserved:
.space 1
bootsig:
.space 1
volid:
.space 4
label:
.space 11
type:
.space 8


begin:
	cli
	sub ax, ax
	mov ax, ss
	mov ax, bx
	mov ax, ds
	mov ax, es
	mov ax, fs
	mov $orig, sp
	sti
	cld

	mov	$orig + hi, si	//say hello
	call	puts
		//move something to 0x10
	call bigreal
	
	//call dumpstk
	//call dumpoff
	//call dumpsegs

	//mov $0x11a1, ax
	//push ax
	//mov $0x22b2, ax
	//push ax
	//mov $0x33c3, ax
	//push ax
	//mov $0x44d4, ax
	//push ax

	//mov $0x55e5, ax
	//push ax	
	//mov $0x66e6, ax
	//push ax

	//call dumpstk
	//call peekstk
	call printsee
	
	mov	$orig + cop, si
	call puts

	//sub di, di	
	//mov $0xf000, ax
	//mov ax, es	
	//movs;

halt:	
	mov	$orig + bye, si
	call	puts
	cli
	halt
	jmp halt

//----debug

enter:
	<\r\n\0>

offmsg:
	<offset:\0>

off:
	mov $orig+offmsg, si
	call puts
	lea orig, bx
	call puthex4
	mov $orig+enter, si
	call puts
ret

psrc:	
	<data is clear>

pdest:	
	<--1234567890-12345678901234567890--\r\n\0>
printsee:
	push $0x0
	push $0x0002
	push $0x00ff
	push $orig+pdest
	push $0x0
	push $orig+psrc

	//call peekstk
	call moveblk

	add $0xc, sp	//put the stack in place

	push $0x0
	push $0x0002
	push $0x0
	push $orig+pdest

	push $0x00ff
	push $orig+pdest
	//call peekstk
	call moveblk

	add $0xc, sp	//put the stack in place.

	mov $orig+pdest, si
	call puts
ret


nams:
	<  sp   cs   ds   ss   es   fs   bp\r\n\0>

dumpsegs:
	push ax
	push bx
	
	mov $orig+nams, si
	call puts

	movb $0x20, al
	call putc

	mov sp, bx
	call puthex4

	movb $0x20, al
	call putc


	mov cs, bx
	call puthex4	

	movb $0x20, al
	call putc
	
	mov ds, bx
	call puthex4

	movb $0x20, al
	call putc

	mov ss, bx
	call puthex4
	
	movb $0x20, al
	call putc
	
	mov es, bx
	call puthex4

	movb $0x20, al
	call putc
	
	mov fs, bx
	call puthex4

	movb $0x20, al
	call putc

	mov bp, bx
	call puthex4


	mov $orig+enter, si
	call puts

	pop bx
	pop ax
ret

peekstk:

	.byte 0x66, 0x8b, 0x76, 0x02	//mov [bp+2], esi
	.byte 0x66
	shr $16, si
	mov si, bx
	call puthex4

	mov sp, bp
	.byte 0x66, 0x8b, 0x76, 0x02	//mov [bp+2], esi
	mov si, bx
	call puthex4

	mov $orig+enter, si
	call puts


	.byte 0x66, 0x8b, 0x7e, 0x06	//mov [bp+06], edi
	.byte 0x66
	shr $16, di
	mov di, bx
	call puthex4


	.byte 0x66, 0x8b, 0x7e, 0x06	//mov [bp+06], edi
	mov di, bx
	call puthex4

	mov $orig+enter, si
	call puts

	.byte 0x66, 0x8b, 0x4e, 0x0a	//mov [bp+0a], ecx
	.byte 0x66
	shr $16, cx
	mov cx, bx
	call puthex4
	
	.byte 0x66, 0x8b, 0x4e, 0x0a	//mov [bp+0a], ecx
	mov cx, bx
	call puthex4

	mov $orig+enter, si
	call puts
ret

dumpstk:
	pop ax
	pop bx
	pop cx
	pop dx
	push dx
	push cx
	push bx
	push ax

	push bx
	mov ax, bx
	call puthex4	
	mov $orig+enter, si
	call puts

	pop bx
	call puthex4	
	mov $orig+enter, si
	call puts

	mov cx, bx
	call puthex4
	mov $orig+enter, si
	call puts

	mov dx, bx
	call puthex4
	mov $orig+enter, si
	call puts

ret

puthex4:
	push al
	movb bh, al
	call puthex2
	movb bl, al
	call puthex2
	pop al
ret
/ write al as two hex digits
puthex2:
	pusha
	push	ax
	
	mov	$2, dx
	movb	$0, ah
	movb	$4, cl
	shr	cl, ax
3:
	cmpb	$10, al
	jls	1f
	subb	$10, al		/ c - 10 + 'A'
	addb	$0x41, al
	jmps	2f
1:
	orb	$0x30, al
2:
	call	putc
	
	dec	dx
	jzs	1f
	
	pop	ax
	push	ax
	and	$0xF, ax
	jmps	3b
1:
	pop	ax
	popa
	ret

//----functions...

//THE function. it copies a N block from 
// ds:esi to es: edi	with ecx as counter (in words of 4 bytes)
// in our scheme ds is near (is an offset of $0)
// es is the high (is a gdt selector from our entry
//				 in bigreal fun)
// before calling, you should:
// push ecx high,
// push ecx low
// push edi high
// push edi low
// push esi high
// push esi low
// add $0xc, sp	put the stack in place.
moveblk:
	//push bp
	cld
	mov sp, bp
	sub ax, ax
	mov ax, ds
	.byte 0x66, 0x8b, 0x76, 0x02	//mov [bp+2], esi -> jump over pc.
	.byte 0x66, 0x8b, 0x7e, 0x06	//mov [bp+06], edi
	.byte 0x66, 0x8b, 0x4e, 0x0a	//mov [bp+0a], ecx

	cld
	rep
	.byte 0x67, 0x66, 0x26, 0xa5	//movsd ds:esi to es:edi
	//pop bp
ret


bigreal:
	//call dumpsegs
	cli
	push bp
	lgdt gdtaddr+orig

				//switch to protected
	.byte 0x0f, 0x20, 0xc0	//mov cr0, eax
	orb $1, al
	.byte 0x0f, 0x22, 0xc0	//mov eax, cr0
	
	mov $next+orig, ax
	jmp ax
next:
	movb $0x10, bl
	movb $0x00, bh
	mov bx, es

	andb $0xfe, al			//back to real mode
	.byte 0x0f, 0x22, 0xc0	//mov eax, cr0
	sti

	inb $0x92			//turn on a20 line, may not work on old
	orb $2, al
	outb $0x92


	sub ax, ax
	pop bp
	//call dumpsegs
ret

puts:
	lodsb
	cmpb	$0, al
	jes	end
	call	putc
	jmp	puts
end:
	ret

putc:	// write the char in al to video

/ write to video
	movb	$0xe, ah
	int	$0x10
	ret

flop:
	mov $0x3f2, dx
	mov $0x10, ax
	outb
	cli
	halt

hi:
	<PbsY\r\n\0>
cop:
	<Copied\r\n\0>
bok:
	<biok\r\n\0>
bye:
	<bye\0>

gdt_limit = gdt_end - gdt - 1

gdtaddr:
	.word	gdt_limit
	.word	orig+gdt, 0x0000	                /* we know the offset */

gdt:
	// selgdt 0
	.word	0x0000, 0x0000		/* dummy */
	.byte	0x00, 0x00, 0x00, 0x00
	//selgdt 0x8

//selgdt 0x8
/* 16-bit 64k code  segment at 000 */
	.word	0xffff, 0x00f0	
	.byte	0x00, 0x9b, 0xcf, 0x00

//selgdt 0x10
/* unreal data segment at 000*/
	.word	0xffff, 0x0000
	.byte	0x00, 0x93, 0xcf, 0x00	
gdt_end:


finish:
	<ffffffffffffffffffffffff\0> //to tell me if it ended...
